$SAFE = 2
$CUR = '%0.2f'

# ***** Code Fixes *****
# Overrides some methods in the base class String.
class String
	alias orig_to_f to_f
	alias orig_to_i to_i
	alias string_format %
	def to_f
		delete(',').orig_to_f
	end
	def to_i
		delete(',').orig_to_i
	end
	def %(arg)
		if (arg.kind_of?(Array) or index('f') == nil)
			string_format(arg)
		else
			value = arg.to_f
			string_format(value < 0.0 ? value - 0.00000001 : value + 0.00000001)
		end
	end

end

# ***** Profile Classes *****
class Individual
 def first_name; ''; end
 def middle_initial; ''; end
 def last_name; ''; end
 def suffix; ''; end
 def address; ''; end
 def apartment_number; ''; end
 def city; ''; end
 def state; ''; end
 def zip; ''; end
 def phone; ''; end
 def work_phone; ''; end
 def mobile_phone; ''; end
 def fax; ''; end
 def ssn; ''; end
 def occupation; ''; end
 def county; ''; end
 def school_code; ''; end
 def email; ''; end
 def blind; ''; end
 def sixty_five_plus; ''; end
 def spouse_first_name; ''; end
 def spouse_middle_initial; ''; end
 def spouse_last_name; ''; end
 def spouse_suffix; ''; end
 def spouse_address; ''; end
 def spouse_apartment_number; ''; end
 def spouse_city; ''; end
 def spouse_state; ''; end
 def spouse_zip; ''; end
 def spouse_phone; ''; end
 def spouse_work_phone; ''; end
 def spouse_mobile_phone; ''; end
 def spouse_fax; ''; end
 def spouse_ssn; ''; end
 def spouse_occupation; ''; end
 def spouse_county; ''; end
 def spouse_school_code; ''; end
 def spouse_email; ''; end
 def spouse_blind; ''; end
 def spouse_65_plus; ''; end
 def single; ''; end
 def married_joint; ''; end
 def married_separate; ''; end
 def head_of_household; ''; end
 def widow_widower; ''; end
 def direct_deposit_checking; ''; end
 def direct_deposit_savings; ''; end
 def routing_number; ''; end
 def account_number; ''; end
 def dependent1_first_name; ''; end
 def dependent1_last_name; ''; end
 def dependent1_ssn; ''; end
 def dependent1_relationship; ''; end
 def dependent1_dob; ''; end
 def dependent2_first_name; ''; end
 def dependent2_last_name; ''; end
 def dependent2_ssn; ''; end
 def dependent2_relationship; ''; end
 def dependent2_dob; ''; end
 def dependent3_first_name; ''; end
 def dependent3_last_name; ''; end
 def dependent3_ssn; ''; end
 def dependent3_relationship; ''; end
 def dependent3_dob; ''; end
 def dependent4_first_name; ''; end
 def dependent4_last_name; ''; end
 def dependent4_ssn; ''; end
 def dependent4_relationship; ''; end
 def dependent4_dob; ''; end
 def dependent5_first_name; ''; end
 def dependent5_last_name; ''; end
 def dependent5_ssn; ''; end
 def dependent5_relationship; ''; end
 def dependent5_dob; ''; end
 def dependent6_first_name; ''; end
 def dependent6_last_name; ''; end
 def dependent6_ssn; ''; end
 def dependent6_relationship; ''; end
 def dependent6_dob; ''; end
 def business_name; ''; end
 def business_address; ''; end
 def business_address2; ''; end
 def business_city; ''; end
 def business_state; ''; end
 def business_zip; ''; end
 def fein; ''; end
 def business_phone; ''; end
 def business_fax; ''; end
 def business_email; ''; end
end

class Preparer
 def first_name; ''; end
 def middle_initial; ''; end
 def last_name; ''; end
 def firm_name; ''; end
 def address; ''; end
 def city; ''; end
 def state; ''; end
 def zip; ''; end
 def phone; ''; end
 def work_phone; ''; end
 def mobile_phone; ''; end
 def fax; ''; end
 def email; ''; end
 def fein; ''; end
 def ptin; ''; end
 def ssn; ''; end
 def self_employed; ''; end
end

class Entity
 def name; ''; end
 def address; ''; end
 def address2; ''; end
 def city; ''; end
 def state; ''; end
 def zip; ''; end
 def phone; ''; end
 def fax; ''; end
 def email; ''; end
 def fein; ''; end
 def state_id; ''; end
 def date_started; ''; end
 def state_of_incorporation; ''; end
 def naics_code; ''; end
 def principal_activity; ''; end
 def contact_name; ''; end
 def contact_title; ''; end
 def contact_phone; ''; end
 def estate_name; ''; end
 def estate_ssn; ''; end
 def estate_dod; ''; end
 def agent_first_name; ''; end
 def agent_middle_initial; ''; end
 def agent_last_name; ''; end
 def agent_business_name; ''; end
 def agent_address; ''; end
 def agent_city; ''; end
 def agent_state; ''; end
 def agent_zip; ''; end
 def agent_phone; ''; end
end

class Fiduciary
 def first_name_and_mi; ''; end
 def last_name; ''; end
 def title; ''; end
 def address; ''; end
 def city; ''; end
 def state; ''; end
 def zip; ''; end
 def phone; ''; end
 def ssn; ''; end
 def estate_name; ''; end
 def ein; ''; end
 def entity_creation_date; ''; end
 def entity_type_decendents; ''; end
 def entity_type_simple; ''; end
 def entity_type_complex; ''; end
 def entity_type_disability; ''; end
 def entity_type_esbt; ''; end
 def entity_type_grantor; ''; end
 def entity_type_bankruptcy_ch7; ''; end
 def entity_type_bankruptcy_ch11; ''; end
 def entity_type_pooled_income; ''; end
 def decedent_first_name_and_mi; ''; end
 def decedent_last_name; ''; end
 def decedent_address; ''; end
 def decedent_city; ''; end
 def decedent_state; ''; end
 def decedent_zip; ''; end
 def decedent_phone; ''; end
 def decedent_ssn; ''; end
 def decedent_dob; ''; end
 def decedent_dod; ''; end
end

class Equifax
def account_name; ''; end
def unemp_tax_yes; ''; end
def unemp_tax_no; ''; end
def local_wh_tax_yes; ''; end
def local_wh_tax_no; ''; end
def wh_tax_yes; ''; end
def wh_tax_no; ''; end
def emp_tax_consult_yes; ''; end
def emp_tax_consult_no; ''; end
def open_new_business; ''; end
def exist_entity_new_in_state; ''; end
def acquire_exist_business; ''; end
def reopen_inactiv_business; ''; end
def change_owner_type_entity; ''; end
def name_change; ''; end
def acct_closures; ''; end
def other_checkbox; ''; end
def other_list; ''; end
def succ_business_name; ''; end
def succ_trade_dba; ''; end
def succ_fein; ''; end
def succ_phone; ''; end
def succ_corp_address; ''; end
def succ_corp_address2; ''; end
def succ_corp_city; ''; end
def succ_corp_state; ''; end
def succ_corp_zip; ''; end
def succ_mailing_address; ''; end
def succ_mailing_address2; ''; end
def succ_mailing_city; ''; end
def succ_mailing_state; ''; end
def succ_mailing_zip; ''; end
def succ_contact_name; ''; end
def succ_contact_title; ''; end
def succ_contact_phone; ''; end
def succ_contact_fax; ''; end
def succ_contact_email; ''; end
def succ_entity_type_corp_public; ''; end
def succ_entity_type_corp_private; ''; end
def succ_entity_type_partnership; ''; end
def succ_entity_type_ltd_partnership; ''; end
def succ_entity_type_scorp; ''; end
def succ_entity_type_other_checkbox; ''; end
def succ_entity_type_other_list; ''; end
def succ_entity_type_llc; ''; end
def succ_entity_type_taxed_as_corp; ''; end
def succ_entity_type_taxed_as_partnership; ''; end
def succ_entity_type_disregarded_entity; ''; end
def succ_entity_type_disregarded_entity_member_name; ''; end
def succ_entity_type_disregarded_entity_member_fein; ''; end
def succ_entity_type_sole_proprietor; ''; end
def succ_state_of_incorporation; ''; end
def succ_date_started; ''; end
def succ_fiscal_yr_end_date; ''; end
def succ_acctng_method_cash; ''; end
def succ_acctng_method_accrual; ''; end
def succ_first_day_of_employment; ''; end
def succ_first_payroll_date; ''; end
def succ_nature_of_business_retail; ''; end
def succ_nature_of_business_wholesale; ''; end
def succ_nature_of_business_manufacturing; ''; end
def succ_nature_of_business_service; ''; end
def succ_nature_of_business_staffing_temp; ''; end
def succ_nature_of_business_prof_emp_org; ''; end
def succ_nature_of_business_other_checkbox; ''; end
def succ_nature_of_business_other_list; ''; end
def succ_business_activity_description; ''; end
def succ_naics_code; ''; end
def succ_501_c_3_exempt_yes; ''; end
def succ_501_c_3_exempt_no; ''; end
def succ_futa_yes; ''; end
def succ_futa_no; ''; end
def succ_futa_date_first_liability; ''; end
def succ_psp_na; ''; end
def succ_psp_name; ''; end
def succ_psp_contact_name; ''; end
def succ_psp_phone; ''; end
def succ_psp_address; ''; end
def succ_psp_city; ''; end
def succ_psp_state; ''; end
def succ_psp_zip; ''; end
def succ_bank_name; ''; end
def succ_bank_address; ''; end
def succ_bank_city; ''; end
def succ_bank_state; ''; end
def succ_bank_zip; ''; end
def succ_bank_phone; ''; end
def succ_bank_acct_number; ''; end
def succ_empl_other_states_yes; ''; end
def succ_empl_other_states_no; ''; end
def succ_empl_other_states_multiple; ''; end
def succ_break_in_employment_yes; ''; end
def succ_break_in_employment_no; ''; end
def succ_total_payroll_quarter; ''; end
def succ_total_payroll_year; ''; end
def succ_20th_wk_date_emp; ''; end
def succ_parent_company_name; ''; end
def succ_parent_company_fein; ''; end
def succ_officer1_name; ''; end
def succ_officer1_title; ''; end
def succ_officer1_ssn_ein; ''; end
def succ_officer1_address; ''; end
def succ_officer1_city; ''; end
def succ_officer1_state; ''; end
def succ_officer1_zip; ''; end
def succ_officer1_dob; ''; end
def succ_officer1_date_of_appt; ''; end
def succ_officer2_name; ''; end
def succ_officer2_title; ''; end
def succ_officer2_ssn_ein; ''; end
def succ_officer2_address; ''; end
def succ_officer2_city; ''; end
def succ_officer2_state; ''; end
def succ_officer2_zip; ''; end
def succ_officer2_dob; ''; end
def succ_officer2_date_of_appt; ''; end
def succ_officer3_name; ''; end
def succ_officer3_title; ''; end
def succ_officer3_ssn_ein; ''; end
def succ_officer3_address; ''; end
def succ_officer3_city; ''; end
def succ_officer3_state; ''; end
def succ_officer3_zip; ''; end
def succ_officer3_dob; ''; end
def succ_officer3_date_of_appt; ''; end
def pred_name; ''; end
def pred_dba; ''; end
def pred_fein; ''; end
def pred_phone; ''; end
def pred_corp_address; ''; end
def pred_corp_address2; ''; end
def pred_corp_city; ''; end
def pred_corp_state; ''; end
def pred_corp_zip; ''; end
def pred_contact_name; ''; end
def pred_contact_phone; ''; end
def pred_contact_mailing_address; ''; end
def pred_contact_mailing_address2; ''; end
def pred_contact_mailing_city; ''; end
def pred_contact_mailing_state; ''; end
def pred_contact_mailing_zip; ''; end
def pred_transaction_date; ''; end
def pred_operating_at_time_of_purchase_yes; ''; end
def pred_operating_at_time_of_purchase_no; ''; end
def pred_transaction_type_asset_purchase; ''; end
def pred_transaction_type_stock_purchase; ''; end
def pred_transaction_type_company_reorg; ''; end
def pred_transaction_type_salutory_merger; ''; end
def pred_transaction_type_other_checkbox; ''; end
def pred_transaction_type_other_list; ''; end
def pred_transaction_type_employee_reassignment; ''; end
def pred_transaction_type_bankruptcy_acq; ''; end
def pred_transaction_type_entity_conversion; ''; end
def pred_acq_all_employment; ''; end
def pred_acq_partial_employment; ''; end
def pred_emp_agency_yes; ''; end
def pred_emp_agency_no; ''; end
def pred_business_description; ''; end
def pred_succ_commonly_owned_yes; ''; end
def pred_succ_commonly_owned_no; ''; end
def pred_succ_commonly_owned_percent; ''; end
def pred_succ_relationship_described; ''; end
def pred_acquired_assets_acct_rec; ''; end
def pred_acquired_assets_machinery_equip; ''; end
def pred_acquired_assets_furniture_fixtures; ''; end
def pred_acquired_assets_goodwill; ''; end
def pred_acquired_assets_buildings; ''; end
def pred_acquired_assets_stock; ''; end
def pred_acquired_assets_other_real_prop_leases; ''; end
def pred_acquired_assets_customer_lists; ''; end
def pred_acquired_assets_employees; ''; end
def pred_acquired_assets_inventories; ''; end
def pred_will_report_wages_yes; ''; end
def pred_will_report_wages_no; ''; end
def pred_last_date_of_emp; ''; end
def pred_date_of_last_payroll; ''; end
def pred_parent_company_name; ''; end
def pred_parent_company_fein; ''; end
def pred_officer1_name; ''; end
def pred_officer1_title; ''; end
def pred_officer1_ssn_ein; ''; end
def pred_officer1_address; ''; end
def pred_officer1_city; ''; end
def pred_officer1_state; ''; end
def pred_officer1_zip; ''; end
def pred_officer1_dob; ''; end
def pred_officer1_date_of_appt; ''; end
def pred_officer2_name; ''; end
def pred_officer2_title; ''; end
def pred_officer2_ssn_ein; ''; end
def pred_officer2_address; ''; end
def pred_officer2_city; ''; end
def pred_officer2_state; ''; end
def pred_officer2_zip; ''; end
def pred_officer2_dob; ''; end
def pred_officer2_date_of_appt; ''; end
def pred_officer3_name; ''; end
def pred_officer3_title; ''; end
def pred_officer3_ssn_ein; ''; end
def pred_officer3_address; ''; end
def pred_officer3_city; ''; end
def pred_officer3_state; ''; end
def pred_officer3_zip; ''; end
def pred_officer3_dob; ''; end
def pred_officer3_date_of_appt; ''; end
def AK_pred_unemp_acct_number; ''; end
def AK_succ_unemp_acct_number; ''; end
def AK_pred_wh_acct_number; ''; end
def AK_address1; ''; end
def AK_city; ''; end
def AK_zip; ''; end
def AK_number_emp_transferred; ''; end
def AK_number_emp_retained; ''; end
def AK_est_mo_wages; ''; end
def AK_est_state_wh_tax; ''; end
def AL_pred_unemp_acct_number; ''; end
def AL_succ_unemp_acct_number; ''; end
def AL_pred_wh_acct_number; ''; end
def AL_address1; ''; end
def AL_city; ''; end
def AL_zip; ''; end
def AL_number_emp_transferred; ''; end
def AL_number_emp_retained; ''; end
def AL_est_mo_wages; ''; end
def AL_est_state_wh_tax; ''; end
def AR_pred_unemp_acct_number; ''; end
def AR_succ_unemp_acct_number; ''; end
def AR_pred_wh_acct_number; ''; end
def AR_address1; ''; end
def AR_city; ''; end
def AR_zip; ''; end
def AR_number_emp_transferred; ''; end
def AR_number_emp_retained; ''; end
def AR_est_mo_wages; ''; end
def AR_est_state_wh_tax; ''; end
def AZ_pred_unemp_acct_number; ''; end
def AZ_succ_unemp_acct_number; ''; end
def AZ_pred_wh_acct_number; ''; end
def AZ_address1; ''; end
def AZ_city; ''; end
def AZ_zip; ''; end
def AZ_number_emp_transferred; ''; end
def AZ_number_emp_retained; ''; end
def AZ_est_mo_wages; ''; end
def AZ_est_state_wh_tax; ''; end
def CA_pred_unemp_acct_number; ''; end
def CA_succ_unemp_acct_number; ''; end
def CA_pred_wh_acct_number; ''; end
def CA_address1; ''; end
def CA_city; ''; end
def CA_zip; ''; end
def CA_number_emp_transferred; ''; end
def CA_number_emp_retained; ''; end
def CA_est_mo_wages; ''; end
def CA_est_state_wh_tax; ''; end
def CO_pred_unemp_acct_number; ''; end
def CO_succ_unemp_acct_number; ''; end
def CO_pred_wh_acct_number; ''; end
def CO_address1; ''; end
def CO_city; ''; end
def CO_zip; ''; end
def CO_number_emp_transferred; ''; end
def CO_number_emp_retained; ''; end
def CO_est_mo_wages; ''; end
def CO_est_state_wh_tax; ''; end
def CT_pred_unemp_acct_number; ''; end
def CT_succ_unemp_acct_number; ''; end
def CT_pred_wh_acct_number; ''; end
def CT_address1; ''; end
def CT_city; ''; end
def CT_zip; ''; end
def CT_number_emp_transferred; ''; end
def CT_number_emp_retained; ''; end
def CT_est_mo_wages; ''; end
def CT_est_state_wh_tax; ''; end
def DC_pred_unemp_acct_number; ''; end
def DC_succ_unemp_acct_number; ''; end
def DC_pred_wh_acct_number; ''; end
def DC_address1; ''; end
def DC_city; ''; end
def DC_zip; ''; end
def DC_number_emp_transferred; ''; end
def DC_number_emp_retained; ''; end
def DC_est_mo_wages; ''; end
def DC_est_state_wh_tax; ''; end
def DE_pred_unemp_acct_number; ''; end
def DE_succ_unemp_acct_number; ''; end
def DE_pred_wh_acct_number; ''; end
def DE_address1; ''; end
def DE_city; ''; end
def DE_zip; ''; end
def DE_number_emp_transferred; ''; end
def DE_number_emp_retained; ''; end
def DE_est_mo_wages; ''; end
def DE_est_state_wh_tax; ''; end
def FL_pred_unemp_acct_number; ''; end
def FL_succ_unemp_acct_number; ''; end
def FL_pred_wh_acct_number; ''; end
def FL_address1; ''; end
def FL_city; ''; end
def FL_zip; ''; end
def FL_number_emp_transferred; ''; end
def FL_number_emp_retained; ''; end
def FL_est_mo_wages; ''; end
def FL_est_state_wh_tax; ''; end
def GA_pred_unemp_acct_number; ''; end
def GA_succ_unemp_acct_number; ''; end
def GA_pred_wh_acct_number; ''; end
def GA_address1; ''; end
def GA_city; ''; end
def GA_zip; ''; end
def GA_number_emp_transferred; ''; end
def GA_number_emp_retained; ''; end
def GA_est_mo_wages; ''; end
def GA_est_state_wh_tax; ''; end
def HI_pred_unemp_acct_number; ''; end
def HI_succ_unemp_acct_number; ''; end
def HI_pred_wh_acct_number; ''; end
def HI_address1; ''; end
def HI_city; ''; end
def HI_zip; ''; end
def HI_number_emp_transferred; ''; end
def HI_number_emp_retained; ''; end
def HI_est_mo_wages; ''; end
def HI_est_state_wh_tax; ''; end
def IA_pred_unemp_acct_number; ''; end
def IA_succ_unemp_acct_number; ''; end
def IA_pred_wh_acct_number; ''; end
def IA_address1; ''; end
def IA_city; ''; end
def IA_zip; ''; end
def IA_number_emp_transferred; ''; end
def IA_number_emp_retained; ''; end
def IA_est_mo_wages; ''; end
def IA_est_state_wh_tax; ''; end
def ID_pred_unemp_acct_number; ''; end
def ID_succ_unemp_acct_number; ''; end
def ID_pred_wh_acct_number; ''; end
def ID_address1; ''; end
def ID_city; ''; end
def ID_zip; ''; end
def ID_number_emp_transferred; ''; end
def ID_number_emp_retained; ''; end
def ID_est_mo_wages; ''; end
def ID_est_state_wh_tax; ''; end
def IL_pred_unemp_acct_number; ''; end
def IL_succ_unemp_acct_number; ''; end
def IL_pred_wh_acct_number; ''; end
def IL_address1; ''; end
def IL_city; ''; end
def IL_zip; ''; end
def IL_number_emp_transferred; ''; end
def IL_number_emp_retained; ''; end
def IL_est_mo_wages; ''; end
def IL_est_state_wh_tax; ''; end
def IN_pred_unemp_acct_number; ''; end
def IN_succ_unemp_acct_number; ''; end
def IN_pred_wh_acct_number; ''; end
def IN_address1; ''; end
def IN_city; ''; end
def IN_zip; ''; end
def IN_number_emp_transferred; ''; end
def IN_number_emp_retained; ''; end
def IN_est_mo_wages; ''; end
def IN_est_state_wh_tax; ''; end
def KS_pred_unemp_acct_number; ''; end
def KS_succ_unemp_acct_number; ''; end
def KS_pred_wh_acct_number; ''; end
def KS_address1; ''; end
def KS_city; ''; end
def KS_zip; ''; end
def KS_number_emp_transferred; ''; end
def KS_number_emp_retained; ''; end
def KS_est_mo_wages; ''; end
def KS_est_state_wh_tax; ''; end
def KY_pred_unemp_acct_number; ''; end
def KY_succ_unemp_acct_number; ''; end
def KY_pred_wh_acct_number; ''; end
def KY_address1; ''; end
def KY_city; ''; end
def KY_zip; ''; end
def KY_number_emp_transferred; ''; end
def KY_number_emp_retained; ''; end
def KY_est_mo_wages; ''; end
def KY_est_state_wh_tax; ''; end
def LA_pred_unemp_acct_number; ''; end
def LA_succ_unemp_acct_number; ''; end
def LA_pred_wh_acct_number; ''; end
def LA_address1; ''; end
def LA_city; ''; end
def LA_zip; ''; end
def LA_number_emp_transferred; ''; end
def LA_number_emp_retained; ''; end
def LA_est_mo_wages; ''; end
def LA_est_state_wh_tax; ''; end
def MA_pred_unemp_acct_number; ''; end
def MA_succ_unemp_acct_number; ''; end
def MA_pred_wh_acct_number; ''; end
def MA_address1; ''; end
def MA_city; ''; end
def MA_zip; ''; end
def MA_number_emp_transferred; ''; end
def MA_number_emp_retained; ''; end
def MA_est_mo_wages; ''; end
def MA_est_state_wh_tax; ''; end
def MD_pred_unemp_acct_number; ''; end
def MD_succ_unemp_acct_number; ''; end
def MD_pred_wh_acct_number; ''; end
def MD_address1; ''; end
def MD_city; ''; end
def MD_zip; ''; end
def MD_number_emp_transferred; ''; end
def MD_number_emp_retained; ''; end
def MD_est_mo_wages; ''; end
def MD_est_state_wh_tax; ''; end
def ME_pred_unemp_acct_number; ''; end
def ME_succ_unemp_acct_number; ''; end
def ME_pred_wh_acct_number; ''; end
def ME_address1; ''; end
def ME_city; ''; end
def ME_zip; ''; end
def ME_number_emp_transferred; ''; end
def ME_number_emp_retained; ''; end
def ME_est_mo_wages; ''; end
def ME_est_state_wh_tax; ''; end
def MI_pred_unemp_acct_number; ''; end
def MI_succ_unemp_acct_number; ''; end
def MI_pred_wh_acct_number; ''; end
def MI_address1; ''; end
def MI_city; ''; end
def MI_zip; ''; end
def MI_number_emp_transferred; ''; end
def MI_number_emp_retained; ''; end
def MI_est_mo_wages; ''; end
def MI_est_state_wh_tax; ''; end
def MN_pred_unemp_acct_number; ''; end
def MN_succ_unemp_acct_number; ''; end
def MN_pred_wh_acct_number; ''; end
def MN_address1; ''; end
def MN_city; ''; end
def MN_zip; ''; end
def MN_number_emp_transferred; ''; end
def MN_number_emp_retained; ''; end
def MN_est_mo_wages; ''; end
def MN_est_state_wh_tax; ''; end
def MO_pred_unemp_acct_number; ''; end
def MO_succ_unemp_acct_number; ''; end
def MO_pred_wh_acct_number; ''; end
def MO_address1; ''; end
def MO_city; ''; end
def MO_zip; ''; end
def MO_number_emp_transferred; ''; end
def MO_number_emp_retained; ''; end
def MO_est_mo_wages; ''; end
def MO_est_state_wh_tax; ''; end
def MS_pred_unemp_acct_number; ''; end
def MS_succ_unemp_acct_number; ''; end
def MS_pred_wh_acct_number; ''; end
def MS_address1; ''; end
def MS_city; ''; end
def MS_zip; ''; end
def MS_number_emp_transferred; ''; end
def MS_number_emp_retained; ''; end
def MS_est_mo_wages; ''; end
def MS_est_state_wh_tax; ''; end
def MT_pred_unemp_acct_number; ''; end
def MT_succ_unemp_acct_number; ''; end
def MT_pred_wh_acct_number; ''; end
def MT_address1; ''; end
def MT_city; ''; end
def MT_zip; ''; end
def MT_number_emp_transferred; ''; end
def MT_number_emp_retained; ''; end
def MT_est_mo_wages; ''; end
def MT_est_state_wh_tax; ''; end
def NC_pred_unemp_acct_number; ''; end
def NC_succ_unemp_acct_number; ''; end
def NC_pred_wh_acct_number; ''; end
def NC_address1; ''; end
def NC_city; ''; end
def NC_zip; ''; end
def NC_number_emp_transferred; ''; end
def NC_number_emp_retained; ''; end
def NC_est_mo_wages; ''; end
def NC_est_state_wh_tax; ''; end
def ND_pred_unemp_acct_number; ''; end
def ND_succ_unemp_acct_number; ''; end
def ND_pred_wh_acct_number; ''; end
def ND_address1; ''; end
def ND_city; ''; end
def ND_zip; ''; end
def ND_number_emp_transferred; ''; end
def ND_number_emp_retained; ''; end
def ND_est_mo_wages; ''; end
def ND_est_state_wh_tax; ''; end
def NE_pred_unemp_acct_number; ''; end
def NE_succ_unemp_acct_number; ''; end
def NE_pred_wh_acct_number; ''; end
def NE_address1; ''; end
def NE_city; ''; end
def NE_zip; ''; end
def NE_number_emp_transferred; ''; end
def NE_number_emp_retained; ''; end
def NE_est_mo_wages; ''; end
def NE_est_state_wh_tax; ''; end
def NH_pred_unemp_acct_number; ''; end
def NH_succ_unemp_acct_number; ''; end
def NH_pred_wh_acct_number; ''; end
def NH_address1; ''; end
def NH_city; ''; end
def NH_zip; ''; end
def NH_number_emp_transferred; ''; end
def NH_number_emp_retained; ''; end
def NH_est_mo_wages; ''; end
def NH_est_state_wh_tax; ''; end
def NJ_pred_unemp_acct_number; ''; end
def NJ_succ_unemp_acct_number; ''; end
def NJ_pred_wh_acct_number; ''; end
def NJ_address1; ''; end
def NJ_city; ''; end
def NJ_zip; ''; end
def NJ_number_emp_transferred; ''; end
def NJ_number_emp_retained; ''; end
def NJ_est_mo_wages; ''; end
def NJ_est_state_wh_tax; ''; end
def NM_pred_unemp_acct_number; ''; end
def NM_succ_unemp_acct_number; ''; end
def NM_pred_wh_acct_number; ''; end
def NM_address1; ''; end
def NM_city; ''; end
def NM_zip; ''; end
def NM_number_emp_transferred; ''; end
def NM_number_emp_retained; ''; end
def NM_est_mo_wages; ''; end
def NM_est_state_wh_tax; ''; end
def NV_pred_unemp_acct_number; ''; end
def NV_succ_unemp_acct_number; ''; end
def NV_pred_wh_acct_number; ''; end
def NV_address1; ''; end
def NV_city; ''; end
def NV_zip; ''; end
def NV_number_emp_transferred; ''; end
def NV_number_emp_retained; ''; end
def NV_est_mo_wages; ''; end
def NV_est_state_wh_tax; ''; end
def NY_pred_unemp_acct_number; ''; end
def NY_succ_unemp_acct_number; ''; end
def NY_pred_wh_acct_number; ''; end
def NY_address1; ''; end
def NY_city; ''; end
def NY_zip; ''; end
def NY_number_emp_transferred; ''; end
def NY_number_emp_retained; ''; end
def NY_est_mo_wages; ''; end
def NY_est_state_wh_tax; ''; end
def OH_pred_unemp_acct_number; ''; end
def OH_succ_unemp_acct_number; ''; end
def OH_pred_wh_acct_number; ''; end
def OH_address1; ''; end
def OH_city; ''; end
def OH_zip; ''; end
def OH_number_emp_transferred; ''; end
def OH_number_emp_retained; ''; end
def OH_est_mo_wages; ''; end
def OH_est_state_wh_tax; ''; end
def OK_pred_unemp_acct_number; ''; end
def OK_succ_unemp_acct_number; ''; end
def OK_pred_wh_acct_number; ''; end
def OK_address1; ''; end
def OK_city; ''; end
def OK_zip; ''; end
def OK_number_emp_transferred; ''; end
def OK_number_emp_retained; ''; end
def OK_est_mo_wages; ''; end
def OK_est_state_wh_tax; ''; end
def OR_pred_unemp_acct_number; ''; end
def OR_succ_unemp_acct_number; ''; end
def OR_pred_wh_acct_number; ''; end
def OR_address1; ''; end
def OR_city; ''; end
def OR_zip; ''; end
def OR_number_emp_transferred; ''; end
def OR_number_emp_retained; ''; end
def OR_est_mo_wages; ''; end
def OR_est_state_wh_tax; ''; end
def PA_pred_unemp_acct_number; ''; end
def PA_succ_unemp_acct_number; ''; end
def PA_pred_wh_acct_number; ''; end
def PA_address1; ''; end
def PA_city; ''; end
def PA_zip; ''; end
def PA_number_emp_transferred; ''; end
def PA_number_emp_retained; ''; end
def PA_est_mo_wages; ''; end
def PA_est_state_wh_tax; ''; end
def PR_pred_unemp_acct_number; ''; end
def PR_succ_unemp_acct_number; ''; end
def PR_pred_wh_acct_number; ''; end
def PR_address1; ''; end
def PR_city; ''; end
def PR_zip; ''; end
def PR_number_emp_transferred; ''; end
def PR_number_emp_retained; ''; end
def PR_est_mo_wages; ''; end
def PR_est_state_wh_tax; ''; end
def RI_pred_unemp_acct_number; ''; end
def RI_succ_unemp_acct_number; ''; end
def RI_pred_wh_acct_number; ''; end
def RI_address1; ''; end
def RI_city; ''; end
def RI_zip; ''; end
def RI_number_emp_transferred; ''; end
def RI_number_emp_retained; ''; end
def RI_est_mo_wages; ''; end
def RI_est_state_wh_tax; ''; end
def SC_pred_unemp_acct_number; ''; end
def SC_succ_unemp_acct_number; ''; end
def SC_pred_wh_acct_number; ''; end
def SC_address1; ''; end
def SC_city; ''; end
def SC_zip; ''; end
def SC_number_emp_transferred; ''; end
def SC_number_emp_retained; ''; end
def SC_est_mo_wages; ''; end
def SC_est_state_wh_tax; ''; end
def SD_pred_unemp_acct_number; ''; end
def SD_succ_unemp_acct_number; ''; end
def SD_pred_wh_acct_number; ''; end
def SD_address1; ''; end
def SD_city; ''; end
def SD_zip; ''; end
def SD_number_emp_transferred; ''; end
def SD_number_emp_retained; ''; end
def SD_est_mo_wages; ''; end
def SD_est_state_wh_tax; ''; end
def TN_pred_unemp_acct_number; ''; end
def TN_succ_unemp_acct_number; ''; end
def TN_pred_wh_acct_number; ''; end
def TN_address1; ''; end
def TN_city; ''; end
def TN_zip; ''; end
def TN_number_emp_transferred; ''; end
def TN_number_emp_retained; ''; end
def TN_est_mo_wages; ''; end
def TN_est_state_wh_tax; ''; end
def TX_pred_unemp_acct_number; ''; end
def TX_succ_unemp_acct_number; ''; end
def TX_pred_wh_acct_number; ''; end
def TX_address1; ''; end
def TX_city; ''; end
def TX_zip; ''; end
def TX_number_emp_transferred; ''; end
def TX_number_emp_retained; ''; end
def TX_est_mo_wages; ''; end
def TX_est_state_wh_tax; ''; end
def UT_pred_unemp_acct_number; ''; end
def UT_succ_unemp_acct_number; ''; end
def UT_pred_wh_acct_number; ''; end
def UT_address1; ''; end
def UT_city; ''; end
def UT_zip; ''; end
def UT_number_emp_transferred; ''; end
def UT_number_emp_retained; ''; end
def UT_est_mo_wages; ''; end
def UT_est_state_wh_tax; ''; end
def VA_pred_unemp_acct_number; ''; end
def VA_succ_unemp_acct_number; ''; end
def VA_pred_wh_acct_number; ''; end
def VA_address1; ''; end
def VA_city; ''; end
def VA_zip; ''; end
def VA_number_emp_transferred; ''; end
def VA_number_emp_retained; ''; end
def VA_est_mo_wages; ''; end
def VA_est_state_wh_tax; ''; end
def VI_pred_unemp_acct_number; ''; end
def VI_succ_unemp_acct_number; ''; end
def VI_pred_wh_acct_number; ''; end
def VI_address1; ''; end
def VI_city; ''; end
def VI_zip; ''; end
def VI_number_emp_transferred; ''; end
def VI_number_emp_retained; ''; end
def VI_est_mo_wages; ''; end
def VI_est_state_wh_tax; ''; end
def VT_pred_unemp_acct_number; ''; end
def VT_succ_unemp_acct_number; ''; end
def VT_pred_wh_acct_number; ''; end
def VT_address1; ''; end
def VT_city; ''; end
def VT_zip; ''; end
def VT_number_emp_transferred; ''; end
def VT_number_emp_retained; ''; end
def VT_est_mo_wages; ''; end
def VT_est_state_wh_tax; ''; end
def WA_pred_unemp_acct_number; ''; end
def WA_succ_unemp_acct_number; ''; end
def WA_pred_wh_acct_number; ''; end
def WA_address1; ''; end
def WA_city; ''; end
def WA_zip; ''; end
def WA_number_emp_transferred; ''; end
def WA_number_emp_retained; ''; end
def WA_est_mo_wages; ''; end
def WA_est_state_wh_tax; ''; end
def WI_pred_unemp_acct_number; ''; end
def WI_succ_unemp_acct_number; ''; end
def WI_pred_wh_acct_number; ''; end
def WI_address1; ''; end
def WI_city; ''; end
def WI_zip; ''; end
def WI_number_emp_transferred; ''; end
def WI_number_emp_retained; ''; end
def WI_est_mo_wages; ''; end
def WI_est_state_wh_tax; ''; end
def WV_pred_unemp_acct_number; ''; end
def WV_succ_unemp_acct_number; ''; end
def WV_pred_wh_acct_number; ''; end
def WV_address1; ''; end
def WV_city; ''; end
def WV_zip; ''; end
def WV_number_emp_transferred; ''; end
def WV_number_emp_retained; ''; end
def WV_est_mo_wages; ''; end
def WV_est_state_wh_tax; ''; end
def WY_pred_unemp_acct_number; ''; end
def WY_succ_unemp_acct_number; ''; end
def WY_pred_wh_acct_number; ''; end
def WY_address1; ''; end
def WY_city; ''; end
def WY_zip; ''; end
def WY_number_emp_transferred; ''; end
def WY_number_emp_retained; ''; end
def WY_est_mo_wages; ''; end
def WY_est_state_wh_tax; ''; end
end

class Fcc
 def applicant_middle_initial; ''; end
 def applicant_suffix; ''; end
 def applicant_address; ''; end
 def applicant_po_box; ''; end
 def applicant_city; ''; end
 def applicant_state; ''; end
 def applicant_zip; ''; end
 def applicant_country; ''; end
 def applicant_frn; ''; end
 def applicant_phone; ''; end
 def applicant_fax; ''; end
 def applicant_email; ''; end
 def contact_first_name; ''; end
 def contact_middle_initial; ''; end
 def contact_last_name; ''; end
 def contact_suffix; ''; end
 def contact_entity_name; ''; end
 def contact_address; ''; end
 def contact_po_box; ''; end
 def contact_city; ''; end
 def contact_state; ''; end
 def contact_zip; ''; end
 def contact_phone; ''; end
 def contact_fax; ''; end
 def contact_email; ''; end
 def signatory_first_name; ''; end
 def signatory_middle_initial; ''; end
 def signatory_last_name; ''; end
 def signatory_suffix; ''; end
 def signatory_title; ''; end
 def applicant_first_name; ''; end
 def applicant_last_name; ''; end
 def applicant_entity_name; ''; end
end

# ***** Field Data *****
box1_1 = ''
box1_2 = ''
box1_3 = ''
box1_4 = ''
box1_5 = ''
box1_6 = ''
box1_7 = ''
box1_8 = ''
box1_9 = ''
box1_10 = ''
box1_11 = ''
box1_12 = ''
box1_13 = ''
box1_14 = ''
box2_1 = ''
box2_2 = ''
box2_3 = ''
box2_4 = ''
box2_5 = ''
box2_6 = ''
box2_7 = ''
box2_8 = ''
box2_9 = ''
box2_10 = ''
box2_11 = ''
box2_12 = ''
box2_13 = ''
box2_14 = ''
box2_15 = ''
box2_16 = ''
box2_17 = ''
box2_18 = ''
box2_19 = ''
box2_20 = ''
box2_21 = ''
box2_22 = ''
box2_23 = ''
box2_24 = ''
box2_25 = ''
box2_26 = ''
box2_27 = ''
box2_28 = ''
box2_29 = ''
box2_30 = ''
box2_31 = ''
box2_32 = ''
box2_33 = ''
box2_34 = ''
box2_35 = ''
box2_36 = ''
box2_37 = ''
box2_38 = ''
box2_39 = ''
box2_40 = ''
box2_41 = ''
box2_42 = ''
box2_43 = ''
box2_44 = ''
box2_45 = ''
box2_46 = ''
box2_47 = ''
box2_48 = ''
box2_49 = ''
box2_50 = ''
box2_51 = ''
box2_52 = ''
box2_53 = ''
box2_54 = ''
box2_55 = ''
box2_56 = ''
box2_57 = ''
box2_58 = ''
box2_59 = ''
box2_60 = ''
box2_61 = ''
box2_62 = ''
box2_63 = ''
box2_64 = ''
box2_65 = ''
box2_66 = ''
box2_67 = ''
box2_68 = ''
box2_69 = ''
box2_70 = ''
box2_71 = ''
box2_72 = ''
box2_73 = ''
box2_74 = ''
box2_75 = ''
box2_76 = ''
box2_77 = ''
box2_78 = ''
box2_79 = ''
box2_80 = ''
box2_81 = ''
box2_82 = ''
box2_83 = ''
box2_84 = ''
box2_85 = ''
box2_86 = ''
box2_87 = ''
box2_88 = ''
box2_89 = ''
box2_90 = ''
box2_91 = ''
box2_92 = ''
box2_93 = ''
box2_94 = ''
box2_95 = ''
box2_96 = ''
box2_97 = ''
box2_98 = ''
box2_99 = ''
box2_100 = ''
box2_101 = ''
box2_102 = ''
box2_103 = ''
box2_104 = ''
box2_105 = ''
box2_106 = ''
box2_107 = ''
box2_108 = ''
box2_109 = ''
box2_110 = ''
box2_111 = ''
box2_112 = ''
box2_113 = ''
box2_114 = ''
box2_115 = ''
box2_116 = ''
box2_117 = ''
box3_1 = ''
box3_2 = ''
box3_3 = ''
box3_4 = ''
box3_5 = ''
box3_6 = ''
box3_7 = ''
box3_8 = ''
box3_9 = ''
box3_10 = ''
box3_11 = ''
box3_12 = ''
box3_13 = ''
box3_14 = ''
box3_15 = ''
box3_16 = ''
box3_17 = ''
box3_18 = ''
box3_19 = ''
box3_20 = ''
box3_21 = ''
box3_22 = ''
box3_23 = ''
box3_24 = ''
box3_25 = ''
box3_26 = ''
box3_27 = ''
box3_28 = ''
box3_29 = ''
box3_30 = ''
box3_31 = ''
box3_32 = ''
box3_33 = ''
box3_34 = ''
box3_35 = ''
box3_36 = ''
box3_37 = ''
box3_38 = ''
box3_39 = ''
box3_40 = ''
box3_41 = ''
box3_42 = ''
box3_43 = ''
box3_44 = ''
box3_45 = ''
box3_46 = ''
box3_47 = ''
box3_48 = ''
box3_49 = ''
box3_50 = ''
box3_51 = ''
box3_52 = ''
box3_53 = ''
box3_54 = ''
box3_55 = ''
box3_56 = ''
box3_57 = ''
box3_58 = ''
box3_59 = ''
box3_60 = ''
box3_61 = ''
box3_62 = ''
box3_63 = ''
box3_64 = ''
box3_65 = ''
box3_66 = ''
box3_67 = ''
box3_68 = ''
box3_69 = ''
box3_70 = ''
box3_71 = ''
box3_72 = ''
box4_1 = ''
box4_2 = ''
box4_3 = ''
box4_4 = ''
box4_5 = ''
box4_6 = ''
box4_7 = ''
box4_8 = ''
box4_9 = ''
box4_10 = ''
box4_11 = ''
box4_12 = ''
box4_13 = ''
box4_14 = ''
box4_15 = ''
box4_16 = ''
box4_17 = ''
box4_18 = ''
box4_19 = ''
box4_20 = ''
box4_21 = ''
box4_22 = ''
box4_23 = ''
box4_24 = ''
box4_25 = ''
box4_26 = ''
box4_27 = ''
box4_28 = ''
box4_29 = ''
box4_30 = ''
box4_31 = ''
box4_32 = ''
box4_33 = ''
box4_34 = ''
box4_35 = ''

# ***** Calculations *****

$,="\x02"
$\="\x03\n"

individual = Individual.new
preparer = Preparer.new

print 'box1_3', 'APT' if !individual.apartment_number.strip.empty?

tmp = individual.apartment_number.strip
print 'box1_4', tmp if !tmp.empty?

tmp = individual.ssn.strip
print 'box2_3', tmp if !tmp.empty?

#If Filing separately SSN is entered here
tmp = individual.spouse_ssn.strip
print 'box2_6', tmp if !tmp.empty?

tmp = individual.first_name.upcase.delete("^A-Z")[0,11]
print 'box2_9', tmp if !tmp.empty?

tmp = individual.middle_initial.upcase.delete("^A-Z")[0,1]
print 'box2_10', tmp if !tmp.empty?

tmp = individual.last_name.upcase.delete("^A-Z")[0,17]
print 'box2_11', tmp if !tmp.empty?

if( !individual.married_joint.strip.empty? )

	tmp = individual.spouse_first_name.upcase.delete("^A-Z")[0,11]
	print 'box2_14', tmp if !tmp.empty?
	
	tmp = individual.spouse_middle_initial.upcase.delete("^A-Z")[0,1]
	print 'box2_15', tmp if !tmp.empty?
	
	tmp = individual.spouse_last_name.upcase.delete("^A-Z")[0,17]
	print 'box2_16', tmp if !tmp.empty?
end

# EMBEDDED spaces are allowed, NOT leading or trailing ones.
tmp = individual.address.strip.upcase.delete("^A-Z0-9 /-")[0,30]
print 'box2_21', tmp if !tmp.empty?

# EMBEDDED spaces are allowed, NOT leading or trailing ones.
tmp = individual.city.strip.upcase.delete("^A-Z0-9 ")[0,17]
print 'box2_26', tmp if !tmp.empty?

tmp = individual.state.strip[0,2]
print 'box2_27', tmp if !tmp.empty?

tmp = individual.zip.strip
print 'box2_28', tmp if !tmp.empty?

print 'box3_3', 'X' if !individual.single.strip.empty?
print 'box3_4', 'X' if !individual.married_joint.strip.empty?

if( !individual.married_separate.strip.empty? )
	print 'box3_5', 'X'
	
	tmp = (individual.spouse_first_name + ' ' + individual.spouse_middle_initial + ' ' + individual.spouse_last_name).squeeze(' ').strip
	print 'box3_6', tmp if !tmp.empty?
end

print 'box3_7', 'X' if !individual.head_of_household.strip.empty?
print 'box3_8', 'X' if !individual.widow_widower.strip.empty?

tmp = (individual.dependent1_first_name + ' ' + individual.dependent1_relationship).squeeze(' ').strip 
print 'box3_18', tmp if !tmp.empty?

tmp = (individual.dependent2_first_name + ' ' + individual.dependent2_relationship).squeeze(' ').strip 
print 'box3_19', tmp if !tmp.empty?

tmp = (individual.dependent3_first_name + ' ' + individual.dependent3_relationship).squeeze(' ').strip 
print 'box3_20', tmp if !tmp.empty?

tmp = ((preparer.self_employed.strip.empty? ? preparer.firm_name : preparer.first_name + ' ' + preparer.middle_initial + ' ' + preparer.last_name) + ' ' + preparer.address + ' ' + (preparer.city.empty? ? '' : preparer.city + ', ') + preparer.state+ ' ' + preparer.zip).squeeze(' ').strip  
print 'box2_111', tmp if !tmp.empty?

tmp = (preparer.ptin.strip.empty? ? preparer.ssn : preparer.ptin).strip
print 'box2_112', tmp if !tmp.empty?

tmp = preparer.fein.strip
print 'box2_113', tmp if !tmp.empty?

#
# End of DataFlow.
#

#
# APE
#
#MMYY or leave blank
if (!box1_6.strip.empty?)
	box2_1 = box1_6[0,2] + box1_6[-2,2]
else
	box2_1 = ''
end
print 'box2_1', box2_1

box2_2 = if (box1_14.strip == 'Y') then 'ATTACH FEDERAL RETURN'
		elsif (box1_14.strip == 'N') then 'DO NOT ATTACH FEDERAL RETURN'
		else ''
		end
print 'box2_2', box2_2

#Name control, no embedded spaces, symbols or punctuation (Last name)
box2_4 = box2_11.delete("^A-Z")[0,4]
print 'box2_4', box2_4

# in order for no "**" to flow, no information on page 1 could have changed from prior year, 
#including dates of death for either taxpayer (box1_1 must be Y, box1_2 must be N, and
#boxes 1_7 thru 1_10 must be empty, to flow "**")

death_info = (box1_7 + box1_8 + box1_9 + box1_10).squeeze(' ').strip

if (box1_1 == 'Y') and (box1_2 == 'N') and (death_info.length == 0) 
	box2_5 = '**'
else
	box2_5 = ''
end
print 'box2_5', box2_5

if (!box2_8.strip.empty?)
	box2_7 = 'PBA'
else
	box2_7 = ''
end
print 'box2_7', box2_7

box2_12 = (box1_8.strip.empty? ? '' : box1_8)
print 'box2_12', box2_12

box2_17 = (box1_10.strip.empty? ? '' : box1_10)
print 'box2_17', box2_17

box2_20 = box1_11.delete("^A-Z0-9")[0,17]
print 'box2_20', box2_20

if (box1_3 =~ /^(APT|STE|SP|RM|FL|BLDG|UN)$/)
	box2_22 = (box1_3.strip)
else
	box2_22 = ''
end
print 'box2_22', box2_22

box2_23 = box1_4.delete("^A-Z0-9")[0,5]
print 'box2_23', box2_23

box2_24 = (box2_25.strip.empty? ? '' : 'PMB')
print 'box2_24', box2_24

box2_31 = (box1_7.strip.empty? ? '' : 'D') + (box1_9.strip.empty? ? '' : 'C')
print 'box2_31', box2_31

box2_32 = (box1_12.strip.empty? ? '' : '9') + (box1_13.strip.empty? ? '' : 'U')
print 'box2_32', box2_32

#End Worksheet

box3_1 = (box2_9 + ' ' + box2_10 + ' ' + box2_11).squeeze(' ').strip
print 'box3_1', box3_1

box3_2 = box2_3
print 'box3_2', box3_2

box3_12 = if (!box3_3.strip.empty?) then '1'
		elsif (!box3_4.strip.empty?) then '2'
		elsif (!box3_5.strip.empty?) then '1'
		elsif (!box3_7.strip.empty?) then '1'
		elsif (!box3_8.strip.empty?) then '2'
		else ''
		end
print 'box3_12', box3_12

#If checked box on line 6, do not enter amount on line 7
box3_13 = (box3_11.strip.empty? ? '%0.2f' %  (box3_12.to_f * 99.0).round : '')
print 'box3_13', box3_13

box3_15 = '%0.2f' %  (box3_14.to_f * 99.0).round
print 'box3_15', box3_15

box3_17 = '%0.2f' %  (box3_16.to_f * 99.0).round
print 'box3_17', box3_17

box3_22 = '%0.2f' %  (box3_21.to_f * 99.0).round
print 'box3_22', box3_22

box3_23 = '%0.2f' %  (box3_13.to_f + box3_15.to_f + box3_17.to_f + box3_22.to_f)
print 'box3_23', box3_23

box3_27 = '%0.2f' %  (box3_25.to_f - box3_26.to_f)
print 'box3_27', box3_27

box3_29 = '%0.2f' %  (box3_27.to_f + box3_28.to_f)
print 'box3_29', box3_29

box3_31 = '%0.2f' %  [box3_29.to_f - box3_30.to_f, 0.0].max
print 'box3_31', box3_31

box3_38 = '%0.2f' %  [box3_36.to_f - box3_37.to_f, 0.0].max
print 'box3_38', box3_38

box3_42= '%0.2f' %  (box3_38.to_f + box3_41.to_f)
print 'box3_42', box3_42

box3_53 = '%0.2f' %  (box3_44.to_f + box3_47.to_f + box3_50.to_f + box3_51.to_f + box3_52.to_f)
print 'box3_53', box3_53

box3_54 = '%0.2f' %  [box3_42.to_f - box3_53.to_f, 0.0].max
print 'box3_54', box3_54

box3_58 = '%0.2f' %  (box3_54.to_f + box3_55.to_f + box3_56.to_f + box3_57.to_f)
print 'box3_58', box3_58

box3_67 = '%0.2f' %  (box3_59.to_f + box3_60.to_f + box3_61.to_f + box3_62.to_f + box3_66.to_f)
print 'box3_67', box3_67

box3_68 = '%0.2f' %  [box3_67.to_f - box3_58.to_f, 0.0].max
print 'box3_68', box3_68

box3_70 = '%0.2f' %  [box3_68.to_f - box3_69.to_f, 0.0].max
print 'box3_70', box3_70

box3_71 = '%0.2f' %  [box3_58.to_f - box3_67.to_f, 0.0].max
print 'box3_71', box3_71

box4_1 = box3_1
print 'box4_1', box4_1

box4_2 = box3_2
print 'box4_2', box4_2

box4_18 = '%0.0f' % ( box4_3.to_f + box4_4.to_f + box4_5.to_f + box4_6.to_f + box4_7.to_f + box4_8.to_f + box4_9.to_f + box4_10.to_f + box4_11.to_f + box4_12.to_f + box4_13.to_f + box4_14.to_f + box4_15.to_f + box4_16.to_f + box4_17.to_f)
print 'box4_18', box4_18

#Note 1/12/11:The note below is from the current instructions. The calc. over the previous years checks for an overpayment and if found
#shows a zero else follows the line instructions. Below is this year's instructions for line 111 instructions

#Line 111  Amount You Owe
#If you have an amount on line 94, add the amount on line 94, line 95, and 
#line 110, if any. Enter the result on line111.
#If you have an amount on line 93, subtract line 95 and line 110 from line93.
#If the combined amount of line 95 and line 110 is more than line93, enter 
#the difference on line 111.
box4_19 = '%0.2f' % (box3_70.to_f != 0.0 ? 0.0 : box3_71.to_f + box3_72.to_f + box4_18.to_f)
print 'box4_19', box4_19

#Note 1/12/11:The notes below are from the instructions for line 115 Refund or No Amount Due. The instructions are the same format
#as they have been for the last few years. The code is not the standard way we usually calc. Refund/Amt.
#Due, but it follows the instructions and was Ok last year.

#Line 115 (Form 540)  Refund or No Amount Due
#Did you report amounts on line 95, line 110, line 112, or line 113?
#No Enter the amount from line 93 on line 115. This is your refund 
#amount. If it is less than $1, attach a written statement to your 
#Form540 requesting the refund.
#Yes Combine the amounts from line 95, line 110, line 112, or line 113. If 
#the result is:
#More than line 93, subtract line 93 from the sum of line 95, 
#line110, line112, and line 113 and enter the result on line 114. 
#This is your total amount due. For payment options, see line 111 
#instructions.
#Less than line 93, subtract the sum of line 95, line 110, line112,
#and line113 from line 93 and enter on line 115. This is your refund

sum = box3_72.to_f + box4_18.to_f + box4_20.to_f + box4_23.to_f

box4_24 = '%0.2f' % if (box4_19.to_f > 0.0) then (box4_19.to_f + box4_20.to_f + box4_23.to_f)
				#Note 2008:SUM variable above is the use tax, contributions, and penalties, and it is checking
				#below to see if it exceeds the overpayment. If it does then we subtract that from the overpayment
				# leaving an amount due.
				elsif (sum > box3_70.to_f) then (sum - box3_70.to_f)
				else 0.0
				end
print 'box4_24', box4_24

box4_25 = if (box4_19.to_f == 0.0)
			if (sum > 0.0) then '%0.2f' % (box3_70.to_f > sum ? box3_70.to_f - sum : 0.0)
			else box3_70
			end
		else
			'%0.2f' % (0.0)
		end
print 'box4_25', box4_25

#End regular calcs.

#
#-################################################################
#
# Scanband:
#
# Column 1
box2_33 = '%0.0f' % if (!box3_3.strip.empty?) then '1'
				elsif (!box3_4.strip.empty?) then '2'
				elsif (!box3_5.strip.empty?) then '3'
				elsif (!box3_7.strip.empty?) then '4'
				elsif (!box3_8.strip.empty?) then '5'
				else ''
				end
print 'box2_33', box2_33

box2_34 = '%0.0f' % (!box3_11.strip.empty? ? '1' : '0')
print 'box2_34', box2_34

box2_35 = '%0.0f' % (box3_16.to_f)
print 'box2_35', box2_35

box2_36 = '%2.0f' %  (box3_21.to_f)
print 'box2_36', box2_36

box2_37 = '%9.0f' % (box3_24.to_f)
print 'box2_37', box2_37

box2_38 = '%9.0f' % (box3_26.to_f)
print 'box2_38', box2_38

box2_39 = '%9.0f' % (box3_28.to_f)
print 'box2_39', box2_39

box2_40 = '%9.0f' % (box3_29.to_f)
print 'box2_40', box2_40

box2_41 = '%9.0f' % (box3_30.to_f)
print 'box2_41', box2_41

box2_42 = '%9.0f' % (box3_36.to_f)
print 'box2_42', box2_42

box2_43 = '%9.0f' % (box3_41.to_f)
print 'box2_43', box2_43

box2_44 = '%9.0f' % (box3_43.to_f)
print 'box2_44', box2_44

box2_45 = '%9.0f' % (box3_44.to_f)
print 'box2_45', box2_45

#
#-########################
#Note 1/12/11:The earlier note below is still applicable:
# Note 2008:State is looking for the 3 digit code as a prefix before the amount.
# The one potential problem with just taking the 2 fields together and formatting
# as a float, is if the code begins with a zero then the zero will be truncated from
# the value that displays in the scanband. But after checking the code chart in the
# instructions, none of the credit codes begins with a zero. So we should be Ok to use
# the same technique below as last year to handle these 2 scanband posts.
#
box2_46 = '%9.0f' % (box3_46 +  box3_47)
print 'box2_46', box2_46

box2_47 = '%9.0f' % (box3_49 +  box3_50)
print 'box2_47', box2_47

#
#-########################
#

box2_48 = '%9.0f' % (box3_51.to_f)
print 'box2_48', box2_48

box2_49 = '%3.0f' % (box3_52.to_f)
print 'box2_49', box2_49

box2_50 = '%9.0f' % (box3_55.to_f)
print 'box2_50', box2_50

box2_51 = '%9.0f' % (box3_56.to_f)
print 'box2_51', box2_51

box2_52 = '%9.0f' % (box3_57.to_f)
print 'box2_52', box2_52

box2_53 = '%9.0f' % (box3_58.to_f)
print 'box2_53', box2_53

box2_54 = '%9.0f' % (box3_59.to_f)
print 'box2_54', box2_54

#
#-###################################################
#
# Column2:
#
box2_55 = '%9.0f' % (box3_60.to_f)
print 'box2_55', box2_55

box2_56 = '%9.0f' % (box3_61.to_f)
print 'box2_56', box2_56

box2_57 = '%9.0f' % (box3_62.to_f)
print 'box2_57', box2_57

#lines 40 and 41 are ssn numbers and the fields that are validated XXX-XX-XXXX. 
box2_58 = (box3_63.delete("^0-9").length == 9 ? box3_63.delete("^0-9") : '%9.0f' % 0)
print 'box2_58', box2_58

box2_59 = (box3_64.delete("^0-9").length == 9 ? box3_64.delete("^0-9") : '%9.0f' % 0)
print 'box2_59', box2_59

box2_60 = '%4.0f' % (box3_65.to_f)
print 'box2_60', box2_60

box2_61 = '%4.0f' % (box3_66.to_f)
print 'box2_61', box2_61

box2_62 = '%9.0f' % (box3_68.to_f)
print 'box2_62', box2_62

box2_63 = '%9.0f' % (box3_69.to_f)
print 'box2_63', box2_63

box2_64 = '%9.0f' % (box3_70.to_f)
print 'box2_64', box2_64

box2_65 = '%9.0f' % (box3_71.to_f)
print 'box2_65', box2_65

box2_66 = '%9.0f' % (box3_72.to_f)
print 'box2_66', box2_66

#Note 1/12/11:The note below is still applicable:
#Note 2008:Below are the contributions codes 400 - 414.
#The first box 400 (CA Seniors Special Fund) has a maximun
#length of 3 so this is why thebox is smaller than the others
#which have a length of 9.
box2_67 = '%3.0f' % (box4_3.to_f)
print 'box2_67', box2_67
 
box2_68 = '%9.0f' % (box4_4.to_f)
print 'box2_68', box2_68

box2_69 = '%9.0f' % (box4_5.to_f)
print 'box2_69', box2_69

box2_70 = '%9.0f' % (box4_6.to_f)
print 'box2_70', box2_70

box2_71 = '%9.0f' % (box4_7.to_f)
print 'box2_71', box2_71

box2_72 = '%9.0f' % (box4_8.to_f)
print 'box2_72', box2_72

box2_73 = '%9.0f' % (box4_9.to_f)
print 'box2_73', box2_73

box2_74 = '%9.0f' % (box4_10.to_f)
print 'box2_74', box2_74

#
#-###################################################
#
# Column 3:
#
box2_75 = '%9.0f' % (box4_11.to_f)
print 'box2_75', box2_75

box2_76 = '%9.0f' % (box4_12.to_f)
print 'box2_76', box2_76

box2_77 = '%9.0f' % (box4_13.to_f)
print 'box2_77', box2_77

box2_78 = '%9.0f' % (box4_14.to_f)
print 'box2_78', box2_78

box2_79 = '%9.0f' % (box4_15.to_f)
print 'box2_79', box2_79

box2_80 = '%9.0f' % (box4_16.to_f)
print 'box2_80', box2_80

box2_81 = '%9.0f' % (box4_17.to_f)
print 'box2_81', box2_81

box2_82 = '%9.0f' % (box4_18.to_f)
print 'box2_82', box2_82

box2_83 = '%9.0f' % (box4_19.to_f)
print 'box2_83', box2_83

box2_84 = '%9.0f' % (box4_20.to_f)
print 'box2_84', box2_84

box2_85 = '%9.0f' % (box4_23.to_f)
print 'box2_85', box2_85

box2_86 = '%9.0f' % (box4_25.to_f)
print 'box2_86', box2_86

box2_87 = '%9.0f' % (box4_30.to_f)
print 'box2_87', box2_87

box2_88 = '%9.0f' % (box4_35.to_f)
print 'box2_88', box2_88

#
#-###################################################
#
# Column 4:
#
if (box1_6.delete('-').length == 6) 
	box2_89 = '%02.0f' % box1_6[0,2] + '%02.0f' % box1_6[-2,2]
else
	box2_89 = '%4.0f' % 0
end
print 'box2_89', box2_89

box2_90 = '%0.0f' % (!box3_10.strip.empty? ? '1' : '0')
print 'box2_90', box2_90

box2_91 = '%0.0f' % (!box3_34.strip.empty? ? '1' : '0')
print 'box2_91', box2_91

box2_92 = '%0.0f' % (!box3_35.strip.empty? ? '1' : '0')
print 'box2_92', box2_92

box2_93 = '%0.0f' % (!box3_39.strip.empty? ? '1' : '0')
print 'box2_93', box2_93

box2_94 = '%0.0f' % (!box3_40.strip.empty? ? '1' : '0')
print 'box2_94', box2_94

box2_95 = case
			when (!box4_21.strip.empty?): '1'
			when (!box4_22.strip.empty?): '2'
			else '0'
		end
print 'box2_95', box2_95

box2_96 = '%0.0f' % (!box2_114.strip.empty? ? '1' : '0')
print 'box2_96', box2_96

box2_97 = ((box2_112)[0,1] == 'P' ? 'P' : '')
print 'box2_97', box2_97

number = box2_112.delete("^0-9")
if (number.length == 8)
	box2_98 = ' ' + number
else
	box2_98 = number
end
print 'box2_98', box2_98

box2_99 = (!box2_113.empty? ? '%9.0f' % box2_113.delete("^0-9") : '')
print 'box2_99', box2_99

#
# 1/12/11: The specs for this year are the same as for 2009 so will keep this area the same.
#
# There must be entries in all 3 fields (Routing Number, Account Number, Account type), else all 3
# fields must be blank in the scanband.
#
if ((!box4_26.strip.empty?) and (!(box4_27 + box4_28).strip.empty?) and (!box4_29.strip.empty?))

	box2_100 = "DDR1"
	box2_101 = '%9s' % box4_26[0,9]
	box2_102 = '%17s' % box4_29[0,17]
	box2_103 = (!box4_27.strip.empty? ? '1' : '2')
else
	box2_100 = ''
	box2_101 = ''
	box2_102 = ''
	box2_103 = ''
end
print 'box2_100', box2_100
print 'box2_101', box2_101
print 'box2_102', box2_102
print 'box2_103', box2_103

if ((!box4_31.strip.empty?) and (!(box4_32 + box4_33).strip.empty?) and (!box4_34.strip.empty?))

	box2_104 = "DDR2"
	box2_105 = '%9s' % box4_31[0,9]
	box2_106 = '%17s' % box4_34[0,17]
	box2_107 = (!box4_32.strip.empty? ? '1' : '2')
else
	box2_104 = ''
	box2_105 = ''
	box2_106 = ''
	box2_107 = ''
end
print 'box2_104', box2_104
print 'box2_105', box2_105
print 'box2_106', box2_106
print 'box2_107', box2_107

#
#-################################################################
